package com.diagbot.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 病案管理人员表
 * </p>
 *
 * @author zhoutg
 * @since 2021-04-06
 */
@Data
public class MedManagementInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 医院ID
     */
    private Long hospitalId;



    /**
     * 0:门诊病案管理人员  1：住院病案管理人员 2：病案编码人员
     */
    private Integer positionId;


    /**
     * 单位时间数据接入开始时间
     */
    private LocalDateTime startDate;

    /**
     * 单位时间数据接入结束时间
     */
    private LocalDateTime endDate;

    /**
     * 单位时间管理人员实际工作总月数
     */
    @TableField("workMouth")
    private Double workMouth;

    /**
     * 是否删除,N:未删除，Y:删除
     */
    private String isDeleted;

    /**
     * 记录创建时间
     */
    private LocalDateTime gmtCreate;

    /**
     * 记录修改时间,如果时间是1970年则表示纪录未修改
     */
    private LocalDateTime gmtModified;

    /**
     * 创建人，0表示无创建人值
     */
    private String creator;

    /**
     * 修改人,如果为0则表示纪录未修改
     */
    private String modifier;

}
